package de.mlessmann.certassist.models;

import java.util.List;
import java.util.Objects;
import java.util.stream.Stream;
import lombok.Builder;
import lombok.Getter;

@Getter
@Builder
public class CertificateInfoExtension {

    private List<String> alternativeDnsNames;

    public static class CertificateInfoExtensionBuilder {

        public CertificateInfoExtensionBuilder alternativeDnsNames(String... altNames) {
            Objects.requireNonNull(altNames, "Alternative names must not be null (but can be empty)");
            this.alternativeDnsNames =
            Stream
                .of(altNames)
                .filter(Objects::nonNull)
                .map(String::trim)
                .map(name -> name.replaceAll("^DNS:", ""))
                .toList();
            return this;
        }
    }
}
