package de.mlessmann.certassist.openssl;

import de.mlessmann.certassist.service.ExecutableResolver;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class AutoBootOpenSSL {

    @Bean
    @ConditionalOnMissingBean(CertificatePasswordProvider.class)
    public CertificatePasswordProvider usageProvider() {
        return new InMemoryCertificatePasswordProvider();
    }

    @Bean
    @ConditionalOnMissingBean(CertificatePasswordProvider.class)
    public OpenSSLService openSSLProvider(
        ExecutableResolver executableResolver,
        CertificatePasswordProvider passwordProvider,
        CertificateProvider usageProvider
    ) {
        return new OpenSSLService(executableResolver, passwordProvider, usageProvider);
    }
}
